-- ------------------------------ --
-- CSPSPC Source (C) 2009 Xiphirx --
-- ---------------------------------
-- ----------------
-- Create Colors --
-- ----------------
	gray = Color.new(96, 96, 96, 255)
	black = Color.new(0,0,0, 255)
	white = Color.new(255,255,255,255)
	orange = Color.new(255,165,0,255)
	blue = Color.new(20,20,196,255)

-- ------------
-- Functions --
-- ------------
	-- Get ICON0.PNG
	function s2i(s)
		return 0x1000000*s:byte(4)+0x10000*s:byte(3)+0x100*s:byte(2)+s:byte(1)
	end
	
	function getIcon(eboot)
		ebootdata = io.open(eboot,'rb')
		ebootdata:seek('set', 0xC)
		icon0png = s2i(ebootdata:read(4))
		icon1pmf = s2i(ebootdata:read(4))
		ebootdata:seek('set', icon0png)
		icon0 = Image.loadFromMemory(ebootdata:read(icon1pmf-icon0png), 1)
		ebootdata:close()
		return icon0
	end
 
	-- marquee for the feed
	function scrolling_marquee(speed)
		xpos = xpos + speed
		string_len = (string.len(Feed) * 7)
		screen.print(xpos, 35, feedarraydata[currentfeed],.6,white,black)
		if speed > 0 then
			if xpos > 480 then
				xpos = 0 - (string_len)
			end
		end
		if speed < 0 then
			if xpos < (0 - string_len) then
				xpos = 480
			end
		end
	end

	-- Get data from a webserver
	function getData(zesocket)
		local dataReceived = ""
		System.setcpuspeed(333)
		repeat
			screen.startDraw()
			local dataRead = zesocket:recv(64)
			dataReceived = dataReceived .. dataRead 
			if string.find(dataReceived,"#$EN") then break end
			screen.endDraw()
			screen.waitVblankStart()
			screen.flipscreen()
		until dataRead == nil

		return dataReceived
	end
	
	-- Remove everything from memory before launching CSPSP
	function setNil()
		screen.clear(black)
		screen.endDraw()
		screen.flipscreen()
		dataReceived = nil
		dataRead = nil
		gray = nil
		black = nil
		white = nil
		orange = nil
		blue = nil
		Background = nil
		Confirmation = nil
		button = nil
		selection = nil
		showingconfirmation = nil
		Feed = nil
		Host = nil
		file = nil
		c = nil
		d = nil
		headerendlocation = nil
		pad = nil
		prevPad = nil
		zey = nil
		for i = 1, numberofmods do
			modarray[i] = nil
			modpatharray[i] = nil
			modiconarray[i] = nil
		end
		for i = 1, numberoffeeds do
			feedarray[i] = nil
			feedarraydata[i] = nil
		end
		numberofmods = nil
		numberoffeeds = nil
		clan = nil
		ServerList = nil
		xpos = nil
		string_len = nil
		speed = nil
		currentfeed = nil
		eboot = nil
		ebootdata = nil
		icon0png = nil
		icon1pmf = nil
		icon0 = nil
	end

-- ---------------
-- Intro Screen --
-- ---------------
	screen.startDraw()
	screen.print(120, 150, "CSPSPCenter 0.1 - Xiphirx", 0.7, white, orange)
	screen.waitVblankStart()
	screen.flipscreen()
	System.sleep(1000) -- wait 2 seconds
	screen.clear(black)
	screen.flipscreen()
	screen.endDraw()
-- -------------------
-- Load some Images --
-- -------------------
	Background = Image.load("gfx/bg.png")
	Confirmation = Image.load("gfx/confirmation.png")
	
-- --------------
-- Load Sounds --
-- --------------
	button = Sound.load("sfx/button.wav")

-- ----------------
-- Load the data --
-- ----------------
	dofile("mods.lua")
	dofile("clan.lua")
	selection = 1
	showingconfirmation = 0
	xpos = 0
	currentfeed = 1

-- ---------------------
-- Connect to the Net --
-- ---------------------

	System.setcpuspeed(75)
	Wlan.init()
	System.setcpuspeed(222)
	-- --------------------
	-- Download the feed --
	-- --------------------
	Feed = "Could not Retrieve"
--If connected
		Host = "xiphirx.netne.net"
		
		for i = 1, numberoffeeds do
			c = Socket.connect(Host, 80)
		
			while not c:isConnected() do System.sleep(100) end
			file = "/feed/" .. feedarray[i] .. ".htm"
			c:send("GET " .. file .. " HTTP/1.0\r\n")
			c:send("HOST: " .. Host .. "\r\n\r\n")
		
			Feed = ""
		
			screen.startDraw()
			screen.print(120, 150, "Retrieving Feed...", 0.7, white, orange)
			screen.waitVblankStart()
			screen.flipscreen()
			screen.endDraw()
		
			Feed = getData(c)

			headerendlocation = string.find(Feed,"\r\n\r\n")
			Feed = string.sub(Feed,(headerendlocation or -4)+4)
			headerendlocation = string.find(Feed, "#$EN")
			Feed = string.sub(Feed, 0, headerendlocation - 1)
			
			feedarraydata[i] = Feed
			c:close()
		end
	
	-- ---------------------------
	-- Download the Server list --
	-- ---------------------------
		Host = "xiphirx.netne.net"
		file = "/cspspc/serverlist.php"
		
		d = Socket.connect(Host, 80)
		
		while not d:isConnected() do System.sleep(100) end
		
		d:send("GET " .. file .. " HTTP/1.0\r\n")
		d:send("HOST: " .. Host .."\r\n\r\n")
		
		ServerList = ""
		
		screen.startDraw()
		screen.clear(black)
		screen.print(120, 150, "Retrieving Servers...", 0.7, white, orange)
		screen.waitVblankStart()
		screen.flipscreen()
		screen.endDraw()
		
		ServerList = getData(d)
		headerendlocation = string.find(ServerList,"\r\n\r\n")
		ServerList = string.sub(ServerList,(headerendlocation or -4)+4)
		headerendlocation = string.find(ServerList, "#$EN") 
		ServerList = string.sub(ServerList, 0, headerendlocation - 1)
		d:close()
	
		Wlan.term()


System.setcpuspeed(222)
-- ------------
-- Main Loop --
-- ------------
	while true do
		-- ------------
		-- Get Input --
		-- ------------
			pad = Controls.read()
			if pad ~= prevPad then
				
				if pad:up() then
					selection = selection - 1
					if selection < 1 then
						selection = 1
					end
				end
				
				if pad:down() then
					selection = selection + 1
					if selection > (numberofmods ) then
						selection = numberofmods
					end
				end
				
				if pad:right() then
					currentfeed = currentfeed + 1
					if currentfeed > (numberoffeeds ) then
						currentfeed = 1
					end
				end
				
				if pad:left() then
					currentfeed = currentfeed - 1
					if currentfeed < (1) then
						currentfeed = numberoffeeds
					end
				end
				
				if pad:cross() and showingconfirmation == 0 then
					showingconfirmation = 1
					button:play()
				end
				
			end
			prevPad = pad
			
			-- ----------------
			-- Start Drawing --
			-- ----------------
				screen.startDraw()
				screen.clear(white)
				
				while showingconfirmation == 1 do
					screen.startDraw()
					Image.blit(0, 0, Background)
					Image.blit(0, 0, Confirmation)
					
					screen.print(59, 114, "Would you like to launch " .. modarray[selection] .. " ?", 0.8, white, black)
					screen.print(128, 174, "X - Launch        O - Cancel" , 0.7, white, black)
					
					pad = Controls.read()
					if pad:cross() and pad ~= prevPad then
						button:play()
						path = modpatharray[selection]
						setNil()
						System.memclean()
						System.runeboot(path)
						path = nil
					end
					
					if pad:circle() then
						button:play()
						showingconfirmation = 0
					end
					prevPad = pad
					
					screen.waitVblankStart()
					screen.endDraw()
					screen.flipscreen()
				end 
				
				if showingconfirmation == 0 then
					-- ------------------
					-- Show menu items --
					-- ------------------
					-- top limit 134
					-- bottom limit 255
						for i = 1, selection - 1 do
							zey = 123 - ((selection - i) * 18)
							if zey > 80 then
								screen.print(15, zey, modarray[i], 0.6, white,black) -- Syntax x, y, Text, Size, Color, Glow Color
							end
						end	
						
						screen.print(15, 123, modarray[selection], 0.6, black,orange)
						
						for i = selection + 1, numberofmods do
							zey = 123 + ((i - selection) * 18)
							if zey < 171 then
								screen.print(15, zey, modarray[i], 0.6, white,black)
							end
						end
						
						

					-- -----------------
					-- Show Clan Feed --
					-- -----------------
						scrolling_marquee(-1.2)
						--screen.print(16,92,Feed,.7,white,blue)
					
					-- ---------------
					-- Show Servers --
					-- ---------------
						screen.print(171,86,ServerList,.6,white,black)
						
					Image.blit(0, 0, Background) -- Draw the BG
					--17,217
						Image.blit(10, 181, modiconarray[selection])
					screen.waitVblankStart()
					screen.endDraw()
					screen.flipscreen()
				end
			prevPad = pad
	end
	System.Quit()
	
